﻿////////////////////////////////////////////////////////////////
//	文字コードの変換
//		Copyright (C) 2008 - 2010 AAOh inc.
////////////////////////////////////////////////////////////////

// Latin1 -> UTF8 変換表
Latin1_ary = [
8364,0,8218,402,8222,8230,8224,8225,710,8240,352,8249,338,0,381,0,0,8216,8217,8220,8221,8226,8211,8212,732,8482,353,8250,339,0,382,376
]
latin1=String.fromCharCode.apply(String, Latin1_ary);

// 問題のあるところだけ取り出す正規表現
Latin1_reg = [];
for(var i=0; i<Latin1_ary.length; i++){
	if(Latin1_ary[i]!=0) Latin1_reg.push(Latin1_ary[i])
};
Latin1_reg = new RegExp( "["+String.fromCharCode.apply(String,Latin1_reg)+"]", "g" );

// 変換の必要のあるところだけ変換
function unLatin1(str){
	return str.replace( Latin1_reg,function(m){
		var i=latin1.indexOf(m[0]);
		if(i!=-1)c=i+128;
		return String.fromCharCode(c);
	});
}

// UTF-8 な文字を取り出す正規表現
Utf8_reg = /[\xc2-\xdf][\x80-\xbf]|\xe0[\xa0-\xbf][\x80-\xbf]|[\xe1-\xef][\x80-\xbf][\x80-\xbf]|\xf0[\x90-\xbf][\x80-\xbf][\x80-\xbf]|[\xf1-\xf3][\x80-\xbf][\x80-\xbf][\x80-\xbf]|\xf4[\x80-\x8f][\x80-\xbf][\x80-\xbf]/g
// UTF-8 から文字列に変換
function utf8ToString(str){
	return str.replace( Utf8_reg, function(s){
		var c = s.charCodeAt(0);
		if((c > 191) && (c < 224)) {
			return String.fromCharCode(((c & 31) << 6) | (s.charCodeAt(1) & 63));
		} else {
			return String.fromCharCode(((c & 15) << 12) | ((s.charCodeAt(1) & 63) << 6) | (s.charCodeAt(2) & 63));
		}
	});
}

/**
 * Latain1からUTF8へ変換します。
 *
 * @param  str Latain1の文字列
 * @return     UTF8の文字列
 */
function getLatin1ToUTF8(str){
	var latin1Str = unLatin1(str);
	var utf8Str   = utf8ToString(latin1Str);

	return utf8Str;
}

